[![KendoReact NPM Banner](https://raw.githubusercontent.com/telerik/kendo-react/master/images/kendoreact-github-banner.png)](https://www.telerik.com/kendo-react-ui/components/free?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-animation&utm_content=banner)

# KendoReact Animation Component for React

> **Important**
>
> -   This package is а part of [KendoReact](https://www.telerik.com/kendo-react-ui?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-animation)&mdash;an enterprise-grade UI library with 120+ free and premium components.
> -   This is a free React Animation component. You can use it even in production, no sign-up or license required. If you're looking for more free React components, check out [Get Started with KendoReact Free](https://www.telerik.com/kendo-react-ui/components/free).
> -   Installing and working with this package indicates that you [accept the KendoReact License Agreement](https://www.telerik.com/purchase/license-agreement/progress-kendoreact?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-animation).
> -   The [30-day free trial](https://www.telerik.com/try/kendo-react-ui?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-animation) gives you access to all KendoReact components and their full functionality. Additionally, for the period of your trial, you can use our legendary technical support provided directly by the KendoReact dev team!

The [React Animation](https://www.telerik.com/kendo-react-ui/animation), part of KendoReact, assists with animating HTML elements which appear, enter or exit the viewport.

How to start:

```sh
npm i @progress/kendo-react-animation
```

## React Animation

> This is a **free React component**&mdash;no sign-up or license required.

The [React Animation Component](https://www.telerik.com/kendo-react-ui/animation), part of KendoReact, delivers a set of features such as:

-   [Types](https://www.telerik.com/kendo-react-ui/components/animation/types/?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-animation)&mdash;The Animation components animate their content by using various animation effects (Fade, Expand, Push, Reveal, Slide and Zoom).
-   [Disabled animations](https://www.telerik.com/kendo-react-ui/components/animation/disabled-state/?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-animation)&mdash;The Animations allow you to enable or disable their showing or hiding effect.
-   [Stacked animations](https://www.telerik.com/kendo-react-ui/components/animation/stacked/?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-animation)&mdash;All Animations extend the Animation component. However, the Push and Zoom Animations further extend Animation by using the [`stackChildren`](https://www.telerik.com/kendo-react-ui/components/animation/api/PushProps/#toc-stackchildren/?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-animation) options and enable you to stack animations.
-   [Life-cycle hooks](https://www.telerik.com/kendo-react-ui/components/animation/hooks/?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-animation)&mdash;When you declaratively add or remove a child element, all Animations call specific hooks during the entering or exiting of the element.
-   [Duration](https://www.telerik.com/kendo-react-ui/components/animation/duration/?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-animation)&mdash;All Animation types enable you to control the duration of the entering and exiting animation effects.
-   [Direction](https://www.telerik.com/kendo-react-ui/components/animation/direction/?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-animation)&mdash;Except for the Fade Animation, the Animations provide a set of the predefined directions which allow you to control their entering and exiting effect
-   [Exiting child components](https://www.telerik.com/kendo-react-ui/components/animation/exiting-components/?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-animation)&mdash;While an exiting child component is rendered because it still exists in the React Virtual DOM, it is no longer available in the DOM.
-   [Theme support](https://www.telerik.com/kendo-react-ui/components/styling/?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-animation)&mdash;The KendoReact Animation, as well as all 100+ components in the KendoReact suite, are styled in three polished themes (Bootstrap, Material, and Default) and can be further customized to match your specific design guidelines.

How to use the Animation component in your apps:

```tsx
import { Slide, Push, Expand, Fade, Zoom, Reveal } from '@progress/kendo-react-animation'; // Import one or more of the available animations based on the design needs of your app.
...
/**
* Handle the logic around when and how the animation is triggered. Use events and life-cycle hooks.
*/
...
<Fade>
    /**
    * Wrap the component that you want to animate with the respective animation type tags.
    */
</Fade>
```

Check out the [KendoReact Animations API](https://www.telerik.com/kendo-react-ui/components/animation/api).

## Support Options

For any issues you might encounter while working with the KendoReact animation, use any of the available support channels:

-   Industry-leading technical support&mdash;KendoReact paid license holders and users with an active (free) trial license can take advantage of our outstanding customer support. To submit a ticket, use [the dedicated KendoReact support system](https://www.telerik.com/account/support-center/contact-us/technical-support?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-animation).
-   Product forums&mdash;The [KendoReact forums](https://www.telerik.com/forums/kendo-ui-react?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-animation) are part of the free support you can get from the community and from the KendoReact team.
-   Feedback portal&mdash;The [KendoReact feedback portal](https://feedback.telerik.com/kendo-react-ui?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-animation) is where you can request and vote for new features to be added.

## Resources

-   [Getting Started with KendoReact](https://www.telerik.com/kendo-react-ui/components/getting-started/?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-animation)
-   [Get Started with KendoReact Free](https://www.telerik.com/kendo-react-ui/components/free)
-   [Get Started with the KendoReact Аnimation](https://www.telerik.com/kendo-react-ui/components/animation/?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-animation)
-   [API Reference of the KendoReact Аnimation](https://www.telerik.com/kendo-react-ui/components/animation/api/АnimationProps/?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-animation)
-   [KendoReact Roadmap](https://www.telerik.com/support/whats-new/kendo-react-ui/roadmap?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-animation)
-   [Blogs](https://www.telerik.com/blogs/tag/kendoreact?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-animation)
-   [Demos, documentation, and component reference](https://www.telerik.com/kendo-react-ui/components/?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-animation)
-   [KendoReact pricing and licensing](https://www.telerik.com/kendo-react-ui/pricing?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-animation)
-   [Changelog](https://www.telerik.com/kendo-react-ui/components/changelogs/ui-for-react/?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-animation)

High-level component overview page:

-   [React Animation Component](https://www.telerik.com/kendo-react-ui/animation)

_Copyright © 2025 Progress Software Corporation and/or its subsidiaries or affiliates. All Rights Reserved._

_Progress, Telerik, and certain product names used herein are trademarks or registered trademarks of Progress Software Corporation and/or one of its subsidiaries or affiliates in the U.S. and/or other countries._
